unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, DBCtrls, Db, TdbDataSet, Grids, DBGrids, ExtCtrls,
  DBCGrids, Menus, ComCtrls, ActnList, TdbBatchMove, TdbTypes;

type
  TTdbSampleForm = class(TForm)
    DBNavigator1: TDBNavigator;
    DepartmentDBGrid: TDBGrid;
    DepartmentTable: TTdbTable;
    DepartmentDataSource: TDataSource;
    DepartmentTableName: TStringField;
    DepartmentTableHomepage: TStringField;
    EmployeeDataSource: TDataSource;
    EmployeeTable: TTdbTable;
    DepartmentTableRecordId: TIntegerField;
    DBNavigator2: TDBNavigator;
    MainMenu1: TMainMenu;
    FileMItem: TMenuItem;
    QuitMItem: TMenuItem;
    EditMItem: TMenuItem;
    PreviousMItem: TMenuItem;
    NextMItem: TMenuItem;
    SearchMItem: TMenuItem;
    LocateMItem: TMenuItem;
    SetFilter1: TMenuItem;
    Export1: TMenuItem;
    csvformat1: TMenuItem;
    commaseparated1: TMenuItem;
    xmlformat1: TMenuItem;
    HelpMitem: TMenuItem;
    AboutMItem: TMenuItem;
    DepartmentSortingBox: TComboBox;
    EmployeeSortingBox: TComboBox;
    EmployeeDBGrid: TDBGrid;
    EmployeeTableName: TStringField;
    EmployeeTableFirstName: TStringField;
    EmployeeTableEMail: TStringField;
    EmployeeTableDepartment: TStringField;
    EmployeeTableSalary: TFloatField;
    EmployeeTableRecordId: TIntegerField;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    StatusBar1: TStatusBar;
    MasterCheckBox: TCheckBox;
    EmployeeExport: TTdbBatchMove;
    ExportTable: TTdbTable;
    FilterCheckBox: TCheckBox;
    procedure DepartmentSortingBoxChange(Sender: TObject);
    procedure EmployeeSortingBoxChange(Sender: TObject);
    procedure MasterCheckBoxClick(Sender: TObject);
    procedure DepartmentTableAfterScroll(DataSet: TDataSet);
    procedure csvformat1Click(Sender: TObject);
    procedure commaseparated1Click(Sender: TObject);
    procedure xmlformat1Click(Sender: TObject);
    procedure LocateMItemClick(Sender: TObject);
    procedure FilterCheckBoxClick(Sender: TObject);
    procedure SetFilter1Click(Sender: TObject);
    procedure AboutMItemClick(Sender: TObject);
    procedure PreviousMItemClick(Sender: TObject);
    procedure NextMItemClick(Sender: TObject);
    procedure QuitMItemClick(Sender: TObject);
    procedure EmployeeDBGridTitleClick(Column: TColumn);
    procedure EmployeeTableAfterPost(DataSet: TDataSet);
    procedure FormShow(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure StartExport;
  end;

var
  TdbSampleForm: TTdbSampleForm;

implementation

{$R *.DFM}
uses
  about, FilterUnit, LocateUnit;
procedure TTdbSampleForm.DepartmentSortingBoxChange(Sender: TObject);
begin
  if DepartmentSortingBox.ItemIndex >= 0 then
  DepartmentTable.IndexName := DepartmentTable.IndexDefs[DepartmentSortingBox.ItemIndex].Name;
end;

procedure TTdbSampleForm.EmployeeSortingBoxChange(Sender: TObject);
begin
  if EmployeeSortingBox.ItemIndex >= 0 then
  EmployeeTable.IndexName := EmployeeTable.IndexDefs[EmployeeSortingBox.ItemIndex].Name;
end;

procedure TTdbSampleForm.MasterCheckBoxClick(Sender: TObject);
begin
  if MasterCheckBox.Checked then
    EmployeeTable.MasterSource := DepartmentDataSource
  else
    EmployeeTable.MasterSource := nil;
  DepartmentTable.Refresh;

  if EmployeeSortingBox.ItemIndex >= 0 then
    EmployeeTable.IndexName := EmployeeTable.IndexDefs[EmployeeSortingBox.ItemIndex].Name;
  EmployeeTable.Refresh;
end;

procedure TTdbSampleForm.DepartmentTableAfterScroll(DataSet: TDataSet);
begin
//  EmployeeTable.IndexName := EmployeeTable.IndexName;
end;

procedure TTdbSampleForm.csvformat1Click(Sender: TObject);
begin
  EmployeeExport.Filename := 'CSVExport.txt';
  EmployeeExport.FileType := tfCSV;
  StartExport;
end;

procedure TTdbSampleForm.commaseparated1Click(Sender: TObject);
begin
  EmployeeExport.Filename := 'CommaExport.txt';
  EmployeeExport.FileType := tfComma;
  StartExport;
end;

procedure TTdbSampleForm.xmlformat1Click(Sender: TObject);
begin
  EmployeeExport.Filename := 'XMLExport.xml';
  EmployeeExport.FileType := tfXML;
  StartExport;
end;

procedure TTdbSampleForm.StartExport;
begin
  // temporary closing all tables and setting
  // employeetable as exporttable
  DepartmentTable.Active := false;
  EmployeeTable.Active := false;
  ExportTable.Active := true;

  EmployeeExport.TdbTable := ExportTable;
  EmployeeExport.Execute;
  // reopening tables
  ExportTable.Active := False;
  DepartmentTable.Active := true;
  EmployeeTable.Active := true;
end;

procedure TTdbSampleForm.LocateMItemClick(Sender: TObject);
var
  LocateForm: TLocateForm;
  Department: String;
begin
  LocateForm:= TLocateForm.Create(Self);
  if LocateForm.ShowModal= mrOk then begin
    Department := LocateForm.Edit1.Text;
    DepartmentTable.Filtered := False;
  end;
  if Assigned(LocateForm) then LocateForm.Free;
  if not DepartmentTable.Locate('Name', Department, [loCaseInsensitive, loPartialKey]) then
  MessageDlg('No matching record',  mtInformation, [mbOk], 0);

end;


procedure TTdbSampleForm.FilterCheckBoxClick(Sender: TObject);
begin
  if FilterCheckBox.Checked then begin
    SetFilter1Click(FilterCheckBox);
  end else begin
    DepartmentTable.Filtered := False;
  end;
end;

procedure TTdbSampleForm.SetFilter1Click(Sender: TObject);
var
  FilterForm: TFilterForm;
begin
  FilterForm:= TFilterForm.Create(Self);
  if FilterForm.ShowModal= mrOk then
  begin
    DepartmentTable.Filter := FilterForm.Edit1.Text;
    try
     DepartmentTable.Filtered := True;
    except
      MessageDlg('No matching record',  mtInformation, [mbOk], 0);
      DepartmentTable.Filtered := False;
    end;
  end else
    DepartmentTable.Filtered := False;
  FilterForm.Free;
  FilterCheckBox.Checked := DepartmentTable.Filtered;

end;

procedure TTdbSampleForm.AboutMItemClick(Sender: TObject);
var
 AboutFrm: TAboutFrm;
begin
  AboutFrm:= TAboutFrm.Create(self);
  AboutFrm.ShowModal;
  AboutFrm.Free;

end;

procedure TTdbSampleForm.PreviousMItemClick(Sender: TObject);
begin
  DepartmentTable.Prior;
end;

procedure TTdbSampleForm.NextMItemClick(Sender: TObject);
begin
  DepartmentTable.Next;
end;

procedure TTdbSampleForm.QuitMItemClick(Sender: TObject);
begin
  Close;
end;

procedure TTdbSampleForm.EmployeeDBGridTitleClick(Column: TColumn);
var
  LocateForm: TLocateForm;
  SearchStr: String;
begin
  LocateForm:= TLocateForm.Create(Self);
  LocateForm.Label1.Caption := Column.FieldName;
  if LocateForm.ShowModal= mrOk then begin
    SearchStr := LocateForm.Edit1.Text;
  end;
  LocateForm.Free;
  if not EmployeeTable.Locate(Column.FieldName, SearchStr, [loCaseInsensitive, loPartialKey]) then
    MessageDlg('No matching record',  mtInformation, [mbOk], 0);
end;

procedure TTdbSampleForm.EmployeeTableAfterPost(DataSet: TDataSet);
begin
//  EmployeeTable.IndexName :=  EmployeeTable.IndexName; 
end;

procedure TTdbSampleForm.FormShow(Sender: TObject);
var
  i: Integer;
begin
  // Indexdefinition
  for i := 1 to DepartmentTable.IndexDefs.Count do
    DepartmentSortingBox.Items.Add(DepartmentTable.IndexDefs[i-1].Fields);
  DepartmentSortingBox.ItemIndex := 0;
  for i := 1 to EmployeeTable.IndexDefs.Count do
    EmployeeSortingBox.Items.Add(EmployeeTable.IndexDefs[i-1].Fields);
  EmployeeSortingBox.ItemIndex := 0;

end;

end.
